# Avorion Script API Documentation

Home Functions Search
Search:

HyperspaceEngine HyperspaceEngine
Properties
blocked
clearSpace
consumerIcon
consumerName
cooldown
cooldownSpeed
currentCooldown
defaultPriority
displayedCooldown
distorted
entity
entityId
isSceneEmpty
passBlocked
range
requiredEnergy
requiredEnergyForJump
Member Functions
block
distort
exhaust
getJumpErrors
isJumpRouteValid
jump
jumpPossible
tryJump

# HyperspaceEngine

function HyperspaceEngine(var id)

Parameters

id The id of the entity this component belongs to, or the entity itself, must be an id of an existing entity or nil for the entity in the current script context

Returns

A new instance of HyperspaceEngine

property bool blocked | [read-only]

True if the hyperspace engine is being blocked.

property bool clearSpace |

Sets the hyperspace engine to "clear space", which speeds up the cooldown to avoid annoying wait times in empty sectors. This value is overridden if the engine is or gets blocked or distorted.

property string consumerIcon | [read-only]

Energy consumer icon of the engine as shown in the energy tab.

property string consumerName | [read-only]

Energy consumer name of the engine as shown in the energy tab.

property float cooldown |

Cooldown in seconds of the engine. Current cooldown is set to this on exhaustion of the hyperspace engine. When this value is changed, it will be overridden once the player builds, reloads or installs upgrades.

property float cooldownSpeed | [read-only]

Cooldown speed factor. Default is 1, can be 0.25 (distorted), 0 (blocked) or up to 3 (clear space). If hyperspace energy efficiency is below 1, this value is adjusted accordingly.

property float currentCooldown |

Current cooldown in seconds of the engine. this is the number that ticks down over time.

property int defaultPriority | [read-only]

Energy consumer default priority of the engine as shown in the energy tab.

property bool displayedCooldown | [read-only]

Cooldown in seconds as it would be displayed to the player. This result varies, depending on distorts, clear space or blockage.

property bool distorted | [read-only]

True if the hyperspace engine is being distorted. This is the case when a ship is under attack or when distort() was called.

property Entity entity | [read-only]

property uuid entityId | [read-only]

property bool isSceneEmpty | [read-only]

Checks if the scene is considered "empty enough" to set "clear space" to true, and thus recharge the engine quicker. This is the case when there are only group, own faction or alliance member ships present

property bool passBlocked |

Whether or not the hyperspace engine is capable of jumping over rifts. When this value is changed, it will be overridden once the player builds or installs upgrades.

property float range |

Range in sectors of the engine. When this value is changed, it will be overridden once the player builds or installs upgrades.

property double requiredEnergy | [read-only]

Currently required energy of the engine as shown in the energy tab.

property float requiredEnergyForJump | [read-only]

Amount of energy in W required to do a hyperspace jump (or rather: recharge the engine)

function var block(float time)

Blocks the hyperspace engine for a certain time. While the hyperspace engine is blocked, it can't jump. For safety reasons, the hyperspace engine can only be blocked for a limited amount of time. You should only block it for a few seconds and then reblock it. Also sets the "clear space" property to false.

Parameters

time The amount of time the engine will be blocked. Doesn't accumulate, overrides previous blocks

Returns

nothing

function var distort(float time)

Distorts the hyperspace engine for a certain time. While the hyperspace engine is distorted, it takes 4x as long to recharge. For safety reasons, the hyperspace engine can only be distorted for a limited amount of time. You should only distort it for a few seconds and then redistort it. Also sets the "clear space" property to false.

Parameters

time The amount of time the engine will be distorted. Doesn't accumulate, overrides previous distorts

Returns

nothing

function var exhaust()

Exhausts the hyperspace engine as if when a jump happens.

Returns

nothing

function int... getJumpErrors(int x, int y)

Checks if a jump to a sector would be possible and returns all errors.

Parameters

x X coordinate of the destination
y Y coordinate of the destination

Returns

a set of JumpError codes containing the reasons why the jump is not possible

function bool, var isJumpRouteValid(int fromX, int fromY, int toX, int toY)

Checks if a hyperspace route would be valid.

Parameters

fromX X coordinate of the origin
fromY Y coordinate of the origin
toX X coordinate of the destination
toY Y coordinate of the destination

Returns

Returns a bool (true, false), and, if false, a string containing the reason why it's invalid

function var jump(int x, int y)

Initiates a hyperspace jump. This is what happens when the player presses space. This will always do the jump, no matter what.

Parameters

x X coordinate of the destination
y Y coordinate of the destination

Returns

nothing

function int jumpPossible(int x, int y)

Checks if a jump to a sector would be possible.

Parameters

x X coordinate of the destination
y Y coordinate of the destination

Returns

a JumpError code containing the reason why the jump is not possible

function int tryJump(int x, int y)

Tries to initiate a hyperspace jump. This is what happens when the player presses space. On failure, this will return a JumpError code with the reason.

Parameters

x X coordinate of the destination
y Y coordinate of the destination

Returns

a JumpError code containing the reason why the jump failed

Overview
Home Functions Search
Search:
Callbacks
Callbacks Alliance [Client] Callbacks Alliance [Server] Callbacks Alliance [Server] Callbacks Entity Callbacks Galaxy Callbacks Player Callbacks Player [Client] Callbacks Sector Callbacks Server Callbacks
Predefined Functions & Example Scripts
Command Entity FactionDatabase PlanGenerator Player Sector Server UsableInventoryItem
Common Components
Boarding BspTree CargoBay CargoLoot ControlUnit CrewComponent DeletionTimer DirectFlightPhysics DockingClamps DockingParent DockingPositions Durability EnergySystem Engine FighterAI Hangar HyperspaceEngine InteractionText InventoryItemLoot Owner Physics Plan ReadOnlyBoarding ReadOnlyBspTree ReadOnlyCargoBay ReadOnlyControlUnit ReadOnlyCrew ReadOnlyDeletionTimer ReadOnlyEnergySystem ReadOnlyEngine ReadOnlyFighterAI ReadOnlyHangar ReadOnlyHyperspaceEngine ReadOnlyInteractionText ReadOnlyOwner ReadOnlyPhysics ReadOnlyPlan ReadOnlyShipAI ReadOnlyShipSystem ReadOnlyTorpedoAI [Server] [Client] [Server] [Client] ReadOnlyTorpedoAI [Server] [Client] [Server] [Client] ReadOnlyTorpedoLauncher ReadOnlyTurretBases ReadOnlyVelocity ReadOnlyWeapons ReadOnlyWormHole Shield ShipAI ShipSystem StructuralIntegrity SystemUpgradeLoot Thrusters Torpedo TorpedoAI TorpedoLauncher Turret TurretAI TurretBases Velocity Weapons WormHole
Common Objects
AllianceMember AllianceRank BlockPlan BlockPlanBlock BlockStatistics Box Captain Color ControlUnitSeat CraftDesign CraftStatsOverview Crew CrewMan CrewProfession DebugInfo dvec2 dvec3 dvec4 Entity EntityDescriptor FighterTemplate Format GameSettings Group HighResolutionTimer Inventory InventoryTurret ivec2 ivec3 ivec4 Language Mail Material Matrix ModManager NamedFormat PlanBspTree PlanetSpecifics PlanGenerationStage PlanPart PlanStyle PlayerId PluralForm Profiler QuadTree Random Rarity Ray ReadOnlyEntity Rect Relation Scenario SectorView Seed Sphere Squad SystemUpgradeTemplate Timer Tooltip TooltipLine TorpedoShaft TorpedoTemplate TradingGood TurretDesign TurretDesignPart TurretTemplate UsableInventoryItem Uuid VanillaInventoryItem vec2 vec3 vec4 Version Weapon
Client Components
EntityIcon EntityTooltip PlanMesh ReadOnlyIcon ReadOnlyPlanMesh ReadOnlyScriptUI ReadOnlyTooltip ScriptUI
Client Objects
Achievements Alliance [Client] CameraKeyFrame CaptainSelectionItem Client ClientSettings ColorSelectionItem CraftDesignSelectionItem Faction [Client] Galaxy [Client] GalaxyMap GameInput GlowFX IconSelectionItem InputWindow InventoryReferenceSelectionItem InventorySelectionItem Keyboard LaserFX Mouse Music PixelIconSelectionItem Planet Player [Client] PlayerWindow RefractionFX Sector [Client] SelectionItem ShipDatabaseEntry [Client] SoundSource StrategyState TargetIndicator TooltipRenderer TurretDesignSelectionItem
Client UI Objects
AllianceEmblem AllianceTab ArrowLine Button [Client] [Client] Button [Client] [Client] CaptainIcon CaptainProfile CheckBox ComboBox ContextMenu CraftPortrait CrewBar Frame Hud InventorySelection Label Line ListBox ListBoxEx MapArrowLine MapIcon MultiLineTextBox NumbersBar Picture PlanDisplayer ProgressBar SavedDesignsSelection ScrollFrame Selection ShipWindow Slider StatisticsBar Tab TabbedWindow TextBox TextField TooltipDisplayer Tree UIArbitraryHorizontalSplitter UIArbitraryVerticalSplitter UIContainer UIElement UIGridSplitter UIHorizontalLister UIHorizontalMultiSplitter UIHorizontalSplitter UIOrganizer UIRect UIRenderer UIVerticalLister UIVerticalMultiSplitter UIVerticalSplitter ValueComboBox Window
Server Components
EntityTransferrer FighterController Loot ReadOnlyEntityTransferrer ReadOnlyFighterController ReadOnlyLoot ReadOnlyTurretController ReadOnlyWreckageCreator TurretController WreckageCreator
Server Objects
Alliance [Server] Faction [Server] Galaxy [Server] Player [Server] ReadOnlySector Sector [Server] Server ShipDatabaseEntry [Server]
Enums
AIState AlliancePrivilege BeamShape BlockShading BlockStructure BlockType BlockType2 BoxType BuildError CaptainGenderId ChatChannel ChatMessageType ComponentType ControlAction ControlActionBit ControlStyle CoolingType CraftStatsOverviewStat CrewProfessionType CrewRank DamageSource DamageType DeletionType Difficulty EntityArrivalType EntityType FighterOrders FighterStartError FighterType FontType ImpactParticles InventoryItemType JumpError KeyboardKey ListBoxEntryType MalusReason MaterialType MoonType MouseButton PlanetType PlanTypeFilter PlayerStateType ProjectileShape RarityType RelationStatus SavedDesignType ScenarioType SectorChangeType ShipAvailability SoundType StatsBonuses TargetIndicatorVisuals TransformationFeature TurretAutoFireMode TurretSlotType WeaponAppearance WeaponCategory

This is the official documentation for the scripting API of Avorion. This documentation is automatically generated and not necessarily complete. Depending on the context in which functions exist, some documentation such as descriptions, return values or variable names or types may be missing.

Work in Progress. Documentation of Avorion Version: 2.5.8 a0d3f0b5b065